/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreChildrensizeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreChildrensize extends TableImpl<VCoreChildrensizeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_childrensize</code>
     */
    public static final VCoreChildrensize V_CORE_CHILDRENSIZE = new VCoreChildrensize();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreChildrensizeRecord> getRecordType() {
        return VCoreChildrensizeRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_childrensize.key_element</code>.
     */
    public final TableField<VCoreChildrensizeRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_childrensize.unique_name</code>.
     */
    public final TableField<VCoreChildrensizeRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_childrensize.number_of_children</code>.
     */
    public final TableField<VCoreChildrensizeRecord, Long> NUMBER_OF_CHILDREN = createField(DSL.name("number_of_children"), SQLDataType.BIGINT, this, "");

    private VCoreChildrensize(Name alias, Table<VCoreChildrensizeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreChildrensize(Name alias, Table<VCoreChildrensizeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_childrensize" as  SELECT e.key_element,
          e.unique_name,
          count(c.key_element) AS number_of_children
         FROM (common_dd.t_core_element_hierarchy e
           LEFT JOIN common_dd.t_core_element_hierarchy c ON ((c.key_parent_element = e.key_element)))
        GROUP BY e.key_element, e.unique_name;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_childrensize</code> table
     * reference
     */
    public VCoreChildrensize(String alias) {
        this(DSL.name(alias), V_CORE_CHILDRENSIZE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_childrensize</code> table
     * reference
     */
    public VCoreChildrensize(Name alias) {
        this(alias, V_CORE_CHILDRENSIZE);
    }

    /**
     * Create a <code>common_dd.v_core_childrensize</code> table reference
     */
    public VCoreChildrensize() {
        this(DSL.name("v_core_childrensize"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreChildrensize as(String alias) {
        return new VCoreChildrensize(DSL.name(alias), this);
    }

    @Override
    public VCoreChildrensize as(Name alias) {
        return new VCoreChildrensize(alias, this);
    }

    @Override
    public VCoreChildrensize as(Table<?> alias) {
        return new VCoreChildrensize(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreChildrensize rename(String name) {
        return new VCoreChildrensize(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreChildrensize rename(Name name) {
        return new VCoreChildrensize(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreChildrensize rename(Table<?> name) {
        return new VCoreChildrensize(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreChildrensize where(Condition condition) {
        return new VCoreChildrensize(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreChildrensize where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreChildrensize where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreChildrensize where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreChildrensize where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreChildrensize where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreChildrensize where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreChildrensize where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreChildrensize whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreChildrensize whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
